package com.brilliance.isc.common.bop.cfa.cfabop.register.impl;

import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.isc.bo.model.Cfabop;
import com.brilliance.isc.bo.model.CfaeadBizInfo;
import com.brilliance.isc.bo.model.CfaecaBizInfo;
import com.brilliance.isc.common.bop.cfa.cfabop.register.CfabopRegister;
import com.brilliance.isc.vo.collection.BcdBizInfoVo;
import org.springframework.stereotype.Service;

@Service("bcd.cfabopRegister")
public class BcdCfabopRegisterImpl implements CfabopRegister {
    @Override
    public void registerCfabopBizInfo(Cfabop cfabop, String cfatyp) {
        if(MdaUtils.isEmpty(cfatyp)){
            cspsLogger.warn("报送类型为空，组数结束!");
            return;
        }

        BcdBizInfoVo bcdbiz = (BcdBizInfoVo) cfabop.getRec();

        //依据报送类型 进行报送要素提取
        switch (cfatyp)
        {
            case "ECA":
                CfaecaBizInfo cfaecaBizInfo = cfabop.getCfaeca().getCfaecaBizInfo();
                cfaecaBizInfo.setFinownref(bcdbiz.getTrtcreVo().getTrdgrp().getRec().getOwnref());
                cfaecaBizInfo.setStttendat(bcdbiz.getTrtcreVo().getTrdgrp().getRec().getOpndat());
                cfaecaBizInfo.setMatdat(bcdbiz.getTrtcreVo().getTrdgrp().getRec().getMatdat());
                cfaecaBizInfo.setCfarat(bcdbiz.getTrtcreVo().getTrdgrp().getRec().getActrat());
                cfaecaBizInfo.setFincod(bcdbiz.getTrtcreVo().getFinmod().getFincod());
                cfaecaBizInfo.setFinamt(bcdbiz.getTrtcreVo().getFinmod().getCbs().getCbe().getAmt());
                cfaecaBizInfo.setIntamt(bcdbiz.getTrtcreVo().getFinmod().getIntamt());
                cfaecaBizInfo.setTotint(bcdbiz.getTrtcreVo().getFinmod().getCbs().getTotint());
                cfaecaBizInfo.setMaxcur(bcdbiz.getTrtcreVo().getTrdgrp().getCbs().getMax().getCur());
                cfaecaBizInfo.setMaxamt(bcdbiz.getTrtcreVo().getTrdgrp().getCbs().getMax().getAmt());
                break;
            case "EAD":
                CfaeadBizInfo cfaeadBizInfo = cfabop.getCfaead().getCfaeadBizInfo();
                cfaeadBizInfo.setDfdownref(bcdbiz.getDftcreVo().getDfdgrp().getRec().getOwnref());
                cfaeadBizInfo.setMatdat(bcdbiz.getDftcreVo().getDfdgrp().getRec().getMatdat());
                cfaeadBizInfo.setStttendat(bcdbiz.getDftcreVo().getDfdgrp().getRec().getStttendat());
                cfaeadBizInfo.setActrat(bcdbiz.getDftcreVo().getDfdgrp().getRec().getActrat());
                cfaeadBizInfo.setFlttyp(bcdbiz.getDftcreVo().getDfdgrp().getRec().getFlttyp());
                cfaeadBizInfo.setBankcn(bcdbiz.getDftcreVo().getDfdgrp().getRec().getBankcn());
                cfaeadBizInfo.setRescur(bcdbiz.getDftcreVo().getDfdgrp().getRec().getRescur());
                cfaeadBizInfo.setResamt(bcdbiz.getDftcreVo().getDfdgrp().getRec().getResamt());
                cfaeadBizInfo.setMaxcur(bcdbiz.getDftcreVo().getDfdgrp().getCbs().getMax().getCur());
                cfaeadBizInfo.setMaxamt(bcdbiz.getDftcreVo().getDfdgrp().getCbs().getMax().getAmt());
                cfaeadBizInfo.setDff(bcdbiz.getDftcreVo().getDfdgrp().getDff());
                break;
            default:
                break;
        }
    }
}
